dhtmlxGantt 与 Svelte 集成

本指南假设你已具备 Svelte 的基本概念和使用模式。如果还不熟悉,可以参考 Svelte 官方文档 的入门教程。

DHTMLX Gantt 与 Svelte 配合良好。你可以在 GitHub 上查看完整示例:DHTMLX Gantt with Svelte Demo

创建项目

在开始新项目之前,建议先安装 Vite(可选)和 Node.js

我们将通过 Vite 来搭建 Svelte 项目。请运行以下命令:

npm create vite@latest

更多详细内容可参考 相关文档

安装依赖

接下来,进入你的应用目录。假设项目名为 gantt-svelte,并选择 svelte 选项。然后运行:

cd gantt-svelte

现在使用你喜欢的包管理器安装依赖并启动应用:

  • 对于 yarn,执行:
yarn install
yarn dev
  • 对于 npm,执行:
npm install
npm run dev

此时,Svelte 项目应已在 http://localhost:5173 运行。

Gantt Svelte app running

创建 Gantt

要添加 DHTMLX Gantt,首先在终端按 Ctrl+C 停止应用,然后安装 Gantt 组件包。

步骤 1. 安装包

PRO 版本的库可通过我们的私有仓库使用 npm/yarn 安装。请按照 此说明 获取访问权限。

获得 Evaluation 版本后,使用以下命令安装:

  • 使用 npm:
npm install @dhx/trial-gantt
  • 使用 yarn:
yarn add @dhx/trial-gantt

或者,由于库的 zip 包结构为 npm 模块,你也可以 从本地文件夹安装

步骤 2. 创建组件

接下来,创建一个 Svelte 组件用于在应用中集成 Gantt。在 src/ 文件夹下新建 Gantt.svelte 文件。

导入源文件

打开 Gantt.svelte 并导入 Gantt 源文件。注意:

  • 如果你是从本地文件夹安装的 Gantt 包,导入方式如下:

Gantt.svelte

import { Gantt} from "dhtmlx-gantt";
import "dhtmlx-gantt/codebase/dhtmlxgantt.css";
  • 如果你安装的是 trial 版本,导入方式如下:

Gantt.svelte

import { Gantt} from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";

本文档以 trial 版本为例。

设置容器并添加 Gantt

要在页面上显示 Gantt,需要定义一个用于渲染组件的容器。示例如下:

Gantt.svelte

<script>
    import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
    import { onMount } from "svelte";
    import { Gantt } from "@dhx/trial-gantt";
 
    let container;
    onMount(() => {
        let gantt = Gantt.getGanttInstance();
        gantt.init(container);
 
        return () => {
            gantt.destructor();
        };
    });
</script>   <div bind:this={container} style="width: 100%; height: 100%;"></div>

如果希望 Gantt 容器填满整个页面,请在 src/ 文件夹下的 app.css 中移除默认样式,并添加如下内容:

src/app.css

body, #app {
  margin: 0;
  padding: 0;
  height: 100vh;
  width: 100%;
}

步骤 3. 将 Gantt 加入应用

现在,将 Gantt 组件引入应用。在 src/App.svelte 中用以下内容替换默认内容:

src/App.svelte

<script>
  import Gantt from "./Gantt.svelte";
</script>
 
<Gantt/>

此时启动应用会显示一个空的 Gantt 图表:

Gantt Svelte init

步骤 4. 提供数据

要为 Gantt 填充数据,新建 src/data.js 文件并添加如下内容:

src/data.js

export function getData() {
  const tasks = {
    data: [
      {
        id: "10",
        text: "Project #1",
        start_date: "01-04-2025",
        duration: 3,
        order: 10,
        progress: 0.4,
        open: true,
      },
      {
        id: "1",
        text: "Task #1",
        start_date: "01-04-2025",
        duration: 1,
        order: 10,
        progress: 0.6,
        parent: "10",
      },
      {
        id: "2",
        text: "Task #2",
        start_date: "02-04-2025",
        duration: 2,
        order: 20,
        progress: 0.6,
        parent: "10",
      },
    ],
    links: [{ id: 1, source: 1, target: 2, type: "0" }],
  };
  return tasks;
}

App.svelte 中将此数据作为 props 传递给 Gantt 组件:

App.svelte

<script>
  import Gantt from "./Gantt.svelte";
  import { getData } from "./data.js";
</script>   <Gantt tasks={getData()} />

然后在 Gantt 组件中通过 gantt.parse() 使用该 props:

Gantt.svelte

<script>
    import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
    import { onMount } from "svelte";
    import { Gantt } from "@dhx/trial-gantt";
 
    export let tasks;
 
    let container;
    onMount(() => {
        let gantt = Gantt.getGanttInstance();
        gantt.init(container);
        gantt.parse(tasks);
 
        return () => {
            gantt.destructor();
        };
    });
</script>   <div bind:this={container} style="width: 100%; height: 100%;"></div>

重新加载应用后,Gantt 图表将会显示任务数据:

Gantt tasks

步骤 5. 数据保存

要跟踪 Gantt 中的数据变化,可以使用 dataProcessor 处理器。它用于与后端通信,可以定义为函数或 router 对象。dhtmlxGantt 支持 Promise 响应,确保操作被正确处理。

通过 createDataProcessor() 创建 DataProcessor,捕获数据变更示例:

gantt.createDataProcessor(function(entity, action, data, id) {​
    gantt.message(`${​entity} ${​action}`);
});

如果后端在创建新记录后会更改任务 ID,确保 Promise 返回对象形如 {id: databaseId}{tid: databaseId},以便 Gantt 能正确更新记录。更多服务端集成细节见这里

至此,你的 Svelte Gantt 集成已准备就绪。欢迎在 GitHub 上查看完整演示:https://github.com/DHTMLX/svelte-gantt-demo

XSS、CSRF 和 SQL 注入攻击

需要注意,Gantt 本身不包含针对 SQL 注入、XSS 或 CSRF 等威胁的内置防护。保护应用免受这些风险是后端开发者的责任。

关于潜在安全漏洞和推荐安全实践,请参阅 应用安全 文章。

Back to top

dhtmlxGantt 与 React 集成

本教程演示如何在 React 应用中使用 JS 版本的 DHTMLX Gantt。如需了解官方 React Gantt 组件,请参阅 React Gantt 文章。

在学习本指南前,建议您具备 React 的基本概念和模式。如果您是 React 新手,可以先阅读 React 文档 以获得入门指导。

DHTMLX Gantt 与 React 配合良好。您可以在 GitHub 上找到相关示例:DHTMLX Gantt with React Demo

创建项目

在创建新项目之前,请确保已安装 Node.js

要快速搭建一个基础的 React 项目,请运行以下命令:

npx create-vite my-react-gantt-app --template react

安装依赖

接下来,进入您的项目文件夹。假设项目名为 my-react-gantt-app,请执行:

cd my-react-gantt-app

然后安装依赖并启动开发服务器。根据您的包管理器,选择以下命令:

  • 使用 yarn
yarn install
yarn dev
  • 使用 npm
npm install
npm run dev

您的 React 应用现在应可通过 http://localhost:5173 访问。

Gantt React app running

创建 Gantt

接下来,我们获取 DHTMLX Gantt 的代码。首先,在终端按 Ctrl+C 停止正在运行的应用。然后安装 Gantt 包。

步骤 1. 安装包

库的 PRO 版本可通过 npm/yarn 从我们的私有仓库获取。请按照 此说明 获取访问权限。

获得 Evaluation 版本后,使用以下命令进行安装:

  • 使用 npm:
npm install @dhx/trial-gantt
  • 使用 yarn:
yarn add @dhx/trial-gantt

另外,由于库的 zip 包结构为 npm 模块,您也可以 从本地文件夹安装

步骤 2. 创建组件

现在,创建一个 React 组件,将 Gantt 集成到您的应用中。在 src/ 目录下添加新文件 Gantt.jsx

引入源文件

打开 Gantt.jsx 并引入 Gantt 源文件。注意以下内容:

  • 如果您是从本地文件夹安装 Gantt 包,您的引入方式如下:

Gantt.jsx

import { Gantt} from "dhtmlx-gantt";
import "dhtmlx-gantt/codebase/dhtmlxgantt.css";
  • 如果您安装的是 trial 版本,请使用以下路径引入:

Gantt.jsx

import { Gantt} from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";

本指南将使用 trial 版本。

设置容器并添加 Gantt

要在页面上渲染 Gantt,需要一个容器元素。Gantt.jsx 文件应包含以下内容:

Gantt.jsx

import { useEffect, useRef } from "react"; import { Gantt } from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
 
export default function GanttView() {   let container = useRef();  
  useEffect(() => {     let gantt = Gantt.getGanttInstance();     gantt.init(container.current);  
    return () => {       gantt.destructor();       container.current.innerHTML = "";     };   }, []);  
  return <div ref={container} style={ {width: "100%", height: "100%"} }></div>; }

步骤 3. 将 Gantt 添加到应用中

接下来,将 Gantt 组件引入到您的应用中。打开 src/app.jsx 并替换默认内容为:

src/app.jsx

import Gantt from "./Gantt";
 
function App() {
  return <Gantt/>;
}
 
export default App;

为确保 Gantt 容器填满整个页面主体,请删除 src/index.css 的默认样式,并添加:

src/index.css

html,
body,
#root {
  height: 100%;
  padding: 0;
  margin: 0;
}

重新启动应用后,您将看到页面上显示一个空的 Gantt 图表:

Gantt React init

步骤 4. 提供数据

要在 Gantt 中展示任务,需要提供数据集。在 src/ 下创建 data.js 文件,内容如下:

src/data.js

export function getData() {
  const tasks = {
    data: [
      {
        id: "10",
        text: "Project #1",
        start_date: "01-04-2025",
        duration: 3,
        order: 10,
        progress: 0.4,
        open: true,
      },
      {
        id: "1",
        text: "Task #1",
        start_date: "01-04-2025",
        duration: 1,
        order: 10,
        progress: 0.6,
        parent: "10",
      },
      {
        id: "2",
        text: "Task #2",
        start_date: "02-04-2025",
        duration: 2,
        order: 20,
        progress: 0.6,
        parent: "10",
      },
    ],
    links: [{ id: 1, source: 1, target: 2, type: "0" }],
  };
  return tasks;
}

App.jsx 中,将此数据作为 props 传递给 Gantt 组件:

App.jsx

import Gantt from "./Gantt";
import { getData } from "./data.js";
 
function App() {
  return <Gantt tasks={getData()} />;
}
 
export default App;

然后,在 Gantt 组件内通过 gantt.parse() 方法使用该 props:

Gantt.jsx

import { useEffect, useRef } from "react";
import { Gantt } from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
 
export default function GanttView(props) {
  let container = useRef();
 
  useEffect(() => {
    let gantt = Gantt.getGanttInstance();
    gantt.init(container.current);
    gantt.parse(props.tasks);  
    return () => {
      gantt.destructor();
      container.current.innerHTML = "";
    };
  }, []);
 
  return <div ref={container} style={ {width: "100%", height: "100%"} }></div>;
}

重新加载应用后,您将看到 Gantt 图表已经填充了任务数据:

Gantt tasks

步骤 5. 保存数据

要处理 Gantt 中的更改,可以使用 dataProcessor 实现与后端的通信。dataProcessor 可以定义为函数或路由对象。dhtmlxGantt 支持 handler 返回 Promise,以便正确处理操作。

通过 createDataProcessor() 创建 DataProcessor 并监听更改,如下所示:

gantt.createDataProcessor(function(entity, action, data, id) {​
    gantt.message(`${​entity} ${​action}`);
});

如果后端在创建记录后分配了新的 id(常见行为),确保 Promise 返回的对象包含 {id: databaseId}{tid: databaseId},以便 Gantt 能正确更新记录。更多信息请参阅 server side integration

至此,您的 React Gantt 已准备就绪。欢迎在 GitHub 上查看完整演示:https://github.com/DHTMLX/react-gantt-demo

XSS、CSRF 和 SQL 注入攻击

请注意,Gantt 本身不负责防护 SQL 注入、XSS 或 CSRF 等安全威胁。确保应用安全是后端开发者的责任。

请参考 Application Security 文章,了解常见漏洞及提升应用安全性的建议。

Back to top

dhtmlxGantt 与 Angular 集成

本指南假设您已具备 Angular 的基础概念和模式。如果需要复习,请参考 Angular 官方文档 中的入门教程。

DHTMLX Gantt 可以与 Angular 平滑集成。您可以在 GitHub 上找到相关示例:DHTMLX Gantt with Angular Demo

创建项目

在创建新项目之前,请确保已安装 Angular CLINode.js

ng new my-angular-gantt-app

该命令会配置所有必要的工具和依赖项,无需额外安装命令。

安装依赖

接下来,进入您的应用目录:

cd my-angular-gantt-app

使用以下命令之一运行应用:

yarn start

npm start

此时,您的应用应可通过 http://localhost:4200 访问。

Gantt Angular app running

创建 Gantt

下一步是获取 DHTMLX Gantt 代码。首先,在命令行按 Ctrl+C 停止应用,然后继续安装 Gantt 包。

步骤 1. 安装包

库的 PRO 版本可通过 npm/yarn 从我们的私有仓库获取。请按照 此说明 获取访问权限。

获得 Gantt 的 Evaluation 版本后,使用以下命令之一进行安装:

  • 使用 npm:
npm install @dhx/trial-gantt
  • 使用 yarn:
yarn add @dhx/trial-gantt

另外,由于 zip 包结构为 npm 模块,您也可以 从本地文件夹安装

步骤 2. 创建组件

为在应用中集成 Gantt,需要创建一个组件。首先在 src/app/ 目录下新建一个 gantt 文件夹,并添加两个文件:gantt.component.tsgantt.component.css

导入源文件

打开 gantt.component.ts 并导入 Gantt 源文件。根据您的安装方式,导入方式有所不同:

  • 如果从本地文件夹安装,导入如下:

gantt.component.ts

import { Gantt } from 'dhtmlx-gantt';

gantt.component.css

@import "@dhtmlx-gantt/codebase/dhtmlxgantt.css";
  • 如果使用试用版,导入如下:

gantt.component.ts

import { Gantt } from '@dhx/trial-gantt';

gantt.component.css

@import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";

本教程使用 trial 版本。

gantt.component.ts 文件将作为 Gantt 组件的模板。添加如下代码:

gantt.component.ts

import { Component, ElementRef, OnInit, 
    ViewChild, ViewEncapsulation } from '@angular/core';
import { Gantt, GanttStatic } from "@dhx/trial-gantt";
 
@Component({
    encapsulation: ViewEncapsulation.None,
    selector: 'gantt',
    styleUrls: ['./gantt.component.css'],
    template: `<div #gantt_here class='gantt-chart'></div>`,
})
export class GanttComponent implements OnInit {
    @ViewChild('gantt_here', { static: true }) ganttContainer!: ElementRef;
    private _gantt?: GanttStatic;
 
    ngOnInit() {
        let gantt = Gantt.getGanttInstance();
        gantt.init(this.ganttContainer.nativeElement);
 
        this._gantt = gantt;
    }
    ngOnDestroy() {
        if (this._gantt) this._gantt.destructor();
    }
}

这里,ngOnInit() 方法用于初始化 Gantt,ngOnDestroy() 在组件销毁时调用 gantt.destructor() 进行清理。

Gantt 的样式放在 gantt.component.css 文件。基础样式如下:

gantt.component.css

@import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
.gantt-chart {
    position: relative;
    width: 100%;
    height: 600px;
}

步骤 3. 将 Gantt 添加到应用中

接下来,将 Gantt 组件集成到应用中。打开 src/app/app.component.ts,用如下内容替换默认内容:

src/app/app.component.ts

import { Component } from '@angular/core';
 
@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent {
  title = 'DHTMLX Gantt with Angular';
}

src/app/ 目录下创建 app.module.ts,并按如下方式引入 GanttComponent

src/app/app.module.ts

import { NgModule } from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";
 
import { AppComponent } from "./app.component";
import { GanttComponent } from './gantt/gantt.component';
 
@NgModule({
  declarations: [AppComponent, GanttComponent],
  imports: [BrowserModule],
  providers: [],
  bootstrap: [AppComponent],
})
export class AppModule {}

src/app/app.component.html 中,用如下内容替换默认内容:

src/app/app.component.html

<gantt></gantt>

最后,更新 src/main.ts 文件内容如下:

src/main.ts

import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";
import { AppModule } from "./app/app.module";
 
platformBrowserDynamic()
  .bootstrapModule(AppModule)
  .catch((err) => console.error(err));

现在启动应用,将会显示一个空白的 Gantt 图表:

Gantt Angular init

步骤 4. 提供数据

要在 Angular Gantt 中加载数据,需要添加任务和链接服务。在此之前,先定义任务和链接模型。

使用以下命令创建任务和链接模型:

ng generate class models/task --skip-tests
ng generate class models/link --skip-tests

models/task.ts 中添加:

models/task.ts

export class Task {
    id!: number;
    start_date!: string;
    text!: string;
    progress!: number;
    duration!: number;
    parent!: number;
}

models/link.ts 中添加:

models/link.ts

export class Link {
     id!: number;
    source!: number;
    target!: number;
    type!: string;
}

接下来,创建任务和链接服务。Angular 中的服务是用于处理特定任务或功能的类,可以在需要的地方进行注入。

使用以下命令生成服务:

ng generate service services/task --flat --skip-tests
ng generate service services/link --flat --skip-tests

services/task.service.ts 中添加:

services/task.service.ts

import { Injectable } from '@angular/core';
import { Task } from '../models/task';
 
@Injectable()
export class TaskService {
    get(): Promise<Task[]>{
        return Promise.resolve([
            { id: 1, text: 'Task #1', start_date: '2023-04-15 00:00', 
                duration: 3, progress: 0.6, parent: 0 },
            { id: 2, text: 'Task #2', start_date: '2023-04-18 00:00', 
                duration: 3, progress: 0.4, parent: 0 }
        ]);
    }
}

services/link.service.ts 中添加:

services/link.service.ts

import { Injectable } from '@angular/core';
import { Link } from '../models/link';
 
@Injectable()
export class LinkService {
    get(): Promise<Link[]> {
        return Promise.resolve([
            { id: 1, source: 1, target: 2, type: '0' }
        ]);
    }
}

@Injectable() 装饰器允许 Angular 的依赖注入系统实例化服务。get() 方法当前返回的是硬编码的数据 Promise,但也可以改为从服务器获取数据。

要在 Gantt 组件中使用这些服务,请在 gantt.component.ts 中导入:

gantt.component.ts

import {TaskService} from "../services/task.service";
import {LinkService} from "../services/link.service";

@Component 装饰器中添加服务为 providers:

gantt.component.ts

@Component({
    encapsulation: ViewEncapsulation.None,
    selector: 'gantt',
    styleUrls: ['./gantt.component.css'],
    providers: [TaskService, LinkService],
    template: `<div #gantt_here class='gantt-chart'></div>`,
})

这样,每个新的 GanttComponent 实例都会创建服务的新实例。

添加构造函数以注入服务:

gantt.component.ts

constructor(private taskService: TaskService, private linkService: LinkService) { }

更新 ngOnInit(),配置日期格式,初始化 Gantt,并从服务加载数据:

gantt.component.ts

let gantt = Gantt.getGanttInstance();
gantt.config.date_format = '%Y-%m-%d %H:%i';
gantt.init(this.ganttContainer.nativeElement);
 
Promise.all([this.taskService.get(), this.linkService.get()])
    .then( ([data, links]) => {
        gantt.parse({ data, links });
    });
this._gantt = gantt;

完整的 gantt.component.ts 文件如下:

gantt.component.ts

import { Component, ElementRef, OnInit, 
    ViewChild, ViewEncapsulation } from '@angular/core';
import { TaskService } from '../services/task.service';
import { LinkService } from '../services/link.service';
import { Gantt, GanttStatic } from "@dhx/trial-gantt";
 
@Component({
    encapsulation: ViewEncapsulation.None,
    selector: 'gantt',
    styleUrls: ['./gantt.component.css'],
    providers: [TaskService, LinkService],
    template: `<div #gantt_here class='gantt-chart'></div>`,
})
export class GanttComponent implements OnInit {
    @ViewChild('gantt_here', { static: true }) ganttContainer!: ElementRef;
    private _gantt?: GanttStatic;
    constructor(private taskService: TaskService, private linkService: LinkService) { }
 
    ngOnInit() {
        let gantt = Gantt.getGanttInstance();
        gantt.config.date_format = '%Y-%m-%d %H:%i';
        gantt.init(this.ganttContainer.nativeElement);
        Promise.all([this.taskService.get(), this.linkService.get()])
            .then(([data, links]) => {
                gantt.parse({ data, links });
            });
        this._gantt = gantt;
    }
    ngOnDestroy() {
        if (this._gantt) this._gantt.destructor();
    }
}

现在重新加载应用页面,Gantt 图表将显示已填充的任务数据:

Gantt Angular events

步骤 5. 保存数据

要追踪 Gantt 中的更改,可以使用 dataProcessor 处理器与服务端后端进行通信。该处理器可以设置为函数或路由对象。dhtmlxGantt 支持从处理器返回 Promise,从而让 Gantt 正确处理操作完成。

可以使用 createDataProcessor() API 方法创建 DataProcessor 并捕获更改,例如:

gantt.createDataProcessor(function(entity, action, data, id) {​
    gantt.message(`${​entity} ${​action}`);
});

如果您的服务在添加新记录后会修改任务 id(很常见),请确保 Promise 返回一个带有 {id: databaseId}{tid: databaseId} 的对象。这样 Gantt 能够用新的数据库 id 更新记录。更多细节请参考 server side information

至此,您的 Angular Gantt 已配置完成。欢迎 在 GitHub 上查看完整演示

XSS、CSRF 与 SQL 注入攻击

请注意,Gantt 本身不提供针对 SQL 注入、XSS 或 CSRF 攻击的防护。确保应用安全是后端开发人员的责任。

请参阅 应用安全 文章,了解组件最易受攻击的区域以及可采取的安全措施。

Back to top

dhtmlxGantt 与 Vue.js 集成

本指南假设你已经具备了 Vue 的基本概念和使用模式。如果你是 Vue 新手,建议先查阅 Vue 3 文档 以快速入门。

DHTMLX Gantt 能很好地与 Vue 集成。你可以在 GitHub 上找到相关示例:DHTMLX Gantt with Vue Demo

创建项目

在开始新项目之前,请确保已经安装了 Node.js

要创建一个 Vue 项目,请运行以下命令:

npm create vue@latest

该命令会安装并运行 create-vue,这是 Vue 官方的项目脚手架工具。更多细节可参考 Vue.js 快速开始

安装依赖

接下来,进入你的应用目录。假设项目名为 gantt-vue

cd gantt-vue

然后使用你的包管理器安装依赖并启动开发服务器:

  • 对于 yarn,运行:
yarn install
yarn dev
  • 对于 npm,运行:
npm install
npm run dev

你的 Vue 项目现在应当运行在 http://localhost:5173

Gantt Vue app running

创建 Gantt

要将 DHTMLX Gantt 添加到项目中,首先在终端中按 Ctrl+C 停止正在运行的应用。然后继续安装 Gantt 包。

步骤 1. 安装包

该库的 PRO 版本可以通过 npm/yarn 从我们的私有仓库安装。请按照 此说明 获取访问权限。

获得 Evaluation 版本后,可使用以下命令安装:

  • 使用 npm:
npm install @dhx/trial-gantt
  • 使用 yarn:
yarn add @dhx/trial-gantt

另外,由于该库的 zip 包结构为 npm 模块,你也可以 从本地文件夹安装

步骤 2. 创建组件

创建一个 Vue 组件,将 Gantt 嵌入到你的应用中。在 src/components/ 目录下新建文件 Gantt.vue

导入源文件

打开 Gantt.vue 并导入 Gantt 源文件。根据你的安装方式,导入方式有所不同:

  • 如果你是从本地文件夹安装,使用:

Gantt.vue

import { Gantt} from "dhtmlx-gantt";
import "dhtmlx-gantt/codebase/dhtmlxgantt.css";
  • 如果你安装的是 trial 版本,使用:

Gantt.vue

import { Gantt} from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";

本指南采用 trial 版本。

设置容器并添加 Gantt

为了在页面上渲染 Gantt,需要指定容器元素。如下所示:

Gantt.vue

<script>
import { Gantt } from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
 
export default {
  mounted() {
    let gantt = Gantt.getGanttInstance();
    gantt.init(this.$refs.cont);
 
    this.gantt = gantt;
  },
  unmounted() {
    this.gantt.destructor();
    this.$refs.cont.innerHTML = "";
  },
};
</script>   <template> <div ref="cont" style="width: 100%; height: 100%"></div> </template>

若需让 Gantt 容器填满整个 body,请移除 src/assetsmain.css 的默认样式,并添加:

src/assets/main.css

body, #app {
  margin: 0;
  padding: 0;
  height: 100vh;
  width: 100%;
}

步骤 3. 将 Gantt 添加到应用

接下来,将 Gantt 组件引入到应用中。打开 src/App.vue,用以下内容替换默认内容:

src/App.vue

<script>
import Gantt from "./components/Gantt.vue";
 
export default {
  components: { Gantt }
};
</script>   <template> <Gantt/> </template>

启动应用后,你会看到一个空的 Gantt 显示:

Gantt Vue init

步骤 4. 提供数据

要在 Gantt 中显示任务,需要提供数据集。在 src/ 目录下创建 data.js 文件,并填入以下数据:

src/data.js

export function getData() {
  const tasks = {
    data: [
      {
        id: "10",
        text: "Project #1",
        start_date: "01-04-2025",
        duration: 3,
        order: 10,
        progress: 0.4,
        open: true,
      },
      {
        id: "1",
        text: "Task #1",
        start_date: "01-04-2025",
        duration: 1,
        order: 10,
        progress: 0.6,
        parent: "10",
      },
      {
        id: "2",
        text: "Task #2",
        start_date: "02-04-2025",
        duration: 2,
        order: 20,
        progress: 0.6,
        parent: "10",
      },
    ],
    links: [{ id: 1, source: 1, target: 2, type: "0" }],
  };
  return tasks;
}

App.vue 中,将该数据作为 props 传递给 Gantt 组件:

App.vue

<script>
import Gantt from "./components/Gantt.vue";
import { getData } from "./data";
 
export default {
  components: { Gantt },
  data() {
    return {
      tasks: getData(),
    };
  },
};
</script>   <template> <Gantt :tasks="tasks" /> </template>

然后在 Gantt 组件中,使用 gantt.parse() 处理这些 props:

Gantt.vue

<script>
import { Gantt } from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
 
export default {
  props: ["tasks"],
 
  mounted() {
    let gantt = Gantt.getGanttInstance();
    gantt.init(this.$refs.cont);
    gantt.parse(this.tasks);
 
    this.gantt = gantt;
  },
  unmounted() {
    this.gantt.destructor();
    this.$refs.cont.innerHTML = "";
  },
};
</script>   <template> <div ref="cont" style="width: 100%; height: 100%"></div> </template>

重新加载应用页面,现在你会看到带有任务的 Gantt:

Gantt tasks

步骤 5. 保存数据

要追踪在 Gantt 中的更改,可以使用 dataProcessor 处理器来管理与后端的通信。该处理器可以是一个函数或路由对象。dhtmlxGantt 支持 handler 返回 Promise,以确保操作完成时得到正确处理。

通过 createDataProcessor() 创建 DataProcessor 并捕获更改,如下所示:

gantt.createDataProcessor(function(entity, action, data, id) {​
    gantt.message(`${​entity} ${​action}`);
});

如果你的后端在创建新记录后会更改任务 ID(许多系统都这样),请确保你的 Promise 返回包含 {id: databaseId}{tid: databaseId} 的对象。这样 Gantt 就能用新的数据库 ID 更新记录。更多详情请参阅 服务端集成

至此,你的 Vue Gantt 集成已完成。你可以在 GitHub 上查看完整 demo:https://github.com/DHTMLX/vue-gantt-demo

XSS、CSRF 和 SQL 注入攻击

需要注意的是,Gantt 本身并不提供针对 SQL 注入、XSS 或 CSRF 等威胁的保护。确保应用安全是后端开发者的责任。

你可以参阅 应用安全 文章,了解常见漏洞及如何增强应用防御能力。

Back to top